#ifndef ADXMAP_H
#define ADXMAP_H

#include <handel.h>
#include <handel_errors.h>
#include <md_generic.h>
#include <handel_constants.h>

#ifdef __cplusplus
extern "C"
{
#endif
int ADXmap_config(const char *portName, int nCards, const char *iniFile, int maxBuffers, size_t maxMemory);
int ADXmap_MapFileConfig(const char *portName, int queueSize, const char *NDArrayPort, int xmapChannel, int maxBuf, int maxMem);
#ifdef __cplusplus
}
#endif

#define XMAP_FIRST_MCA_CMD mcaData
#define XMAP_LAST_MCA_CMD  mcaElapsedCounts
#define XMAP_FIRST_XIA_CMD xia_peaking_time
#define XMAP_LAST_XIA_CMD  xia_buffer_overrun
#define XMAP_FIRST_CMD     XMAP_LAST_XIA_CMD + 1


#define XMAP_ALL                  -1
#define XMAP_NCHANS_MODULE         4
#define XMAP_MAX_MCA_BINS      16384
#define XMAP_MIN_MCA_BINS        256
#define XMAP_N_RUNTIME_STATS       7
#define XMAP_MCA_BIN_RES         256
#define XMAP_MAX_MAPBUF_SIZE 2097152   /** < The maximum number of bytes in the 2MB mapping mode buffer */
#define MEGABYTE             1048576

#define TRUE                       1
#define FALSE                      0


#endif
