#include "drvXmap.h"

static xmap_command_t xmap_xia_commands[59] = {

	/* Acquisition values (commands for xiaSetAcquisitionValues() and xiaGetAcquisitionValues() ) */
	{xia_peaking_time,             "xia_peaking_time","peaking_time",XMAP_FLOAT64},
	{xia_dynamic_range,            "xia_dynamic_range","dynamic_range",XMAP_FLOAT64},
	{xia_trigger_threshold,        "xia_trigger_threshold","trigger_threshold",XMAP_FLOAT64},
	{xia_baseline_threshold,       "xia_baseline_threshold","baseline_threshold",XMAP_FLOAT64},
	{xia_energy_threshold,         "xia_energy_threshold","energy_threshold",XMAP_FLOAT64},
	{xia_calibration_energy,       "xia_calibration_energy","calibration_energy",XMAP_FLOAT64},
	{xia_adc_percent_rule,         "xia_adc_percent_rule","adc_percent_rule",XMAP_FLOAT64},
	{xia_mca_bin_width,            "xia_mca_bin_width","mca_bin_width",XMAP_FLOAT64},
	{xia_preamp_gain,              "xia_preamp_gain","preamp_gain",XMAP_FLOAT64},
	{xia_number_mca_channels,      "xia_number_mca_channels","number_mca_channels",XMAP_FLOAT64},
	{xia_detector_polarity,        "xia_detector_polarity","detector_polarity",XMAP_FLOAT64},
	{xia_reset_delay,              "xia_reset_delay","reset_delay",XMAP_FLOAT64},
	{xia_gap_time,                 "xia_gap_time","gap_time",XMAP_FLOAT64},
	{xia_trigger_peaking_time,     "xia_trigger_peaking_time","trigger_peaking_time",XMAP_FLOAT64},
	{xia_trigger_gap_time,         "xia_trigger_gap_time","trigger_gap_time",XMAP_FLOAT64},
	{xia_baseline_average,         "xia_baseline_average","baseline_average",XMAP_FLOAT64},
	{xia_preset_type,              "xia_preset_type","preset_type",XMAP_FLOAT64},
	{xia_preset_value,             "xia_preset_value","preset_value",XMAP_FLOAT64},
	{xia_number_of_scas,           "xia_number_of_scas","number_of_scas",XMAP_FLOAT64},
	{xia_mapping_mode,             "xia_mapping_mode","mapping_mode",XMAP_FLOAT64},
	{xia_num_map_pixels,           "xia_num_map_pixels","num_map_pixels",XMAP_FLOAT64},
	{xia_num_map_pixels_per_buffer,"xia_num_map_pixels_per_buffer","num_map_pixels_per_buffer",XMAP_FLOAT64},
	{xia_input_logic_polarity,     "xia_input_logic_polarity","input_logic_polarity",XMAP_FLOAT64},
	{xia_gate_master,              "xia_gate_master","gate_master",XMAP_FLOAT64},
	{xia_sync_master,              "xia_sync_master","sync_master",XMAP_FLOAT64},
	{xia_sync_count,               "xia_sync_count","sync_count",XMAP_FLOAT64},
	{xia_gate_ignore,              "xia_gate_ignore","gate_ignore",XMAP_FLOAT64},
	{xia_lbus_master,              "xia_lbus_master","lbus_master",XMAP_FLOAT64},
	{xia_pixel_advance_mode,       "xia_pixel_advance_mode","pixel_advance_mode",XMAP_FLOAT64},
	{xia_minimum_gap_time,         "xia_minimum_gap_time","minimum_gap_time",XMAP_FLOAT64},
	{xia_synchronous_run,          "xia_synchronous_run","synchronous_run",XMAP_FLOAT64},
	{xia_maxwidth,                 "xia_maxwidth","maxwidth",XMAP_FLOAT64},
	{xia_preamp_type,              "xia_preamp_type","preamp_type",XMAP_FLOAT64},
	{xia_decay_time,               "xia_decay_time","decay_time",XMAP_FLOAT64},

	{xia_sca_n_lohi,               "xia_sca_n_lohi","sca_n_lohi",XMAP_FLOAT64},			/* special case with 'n' and 'hi'/'lo'?? */
	{xia_peak_sample_offset_n,     "xia_peak_sample_offset_n","peak_sample_offset_n",XMAP_FLOAT64},  /* special case with 'n' */

	/* Board operations (commands for xiaBoardOperation() ) */
	{xia_apply,                    "xia_apply","apply",XMAP_NONE_TYPE},
	{xia_buffer_done,              "xia_buffer_done","buffer_done",XMAP_NONE_TYPE},
	{xia_mapping_pixel_next,       "xia_mapping_pixel_next","mapping_pixel_next",XMAP_NONE_TYPE},

	/* Run time data (commands for xiaGetRunData() ) */
	{xia_mca_length,               "xia_mca_length","mca_length",XMAP_INT32},
	{xia_mca,                      "xia_mca","mca",XMAP_INT32ARRAY},
	{xia_baseline_length,          "xia_baseline_length","baseline_length",XMAP_INT32},
	{xia_baseline,                 "xia_baseline","baseline",XMAP_INT32ARRAY},
	{xia_runtime,                  "xia_runtime","runtime",XMAP_FLOAT64},
	{xia_realtime,                 "xia_realtime","realtime",XMAP_FLOAT64},
	{xia_events_in_run,            "xia_events_in_run","events_in_run",XMAP_INT32},
	{xia_trigger_livetime,         "xia_trigger_livetime","trigger_livetime",XMAP_FLOAT64},
	{xia_livetime,                 "xia_livetime","livetime",XMAP_FLOAT64},
	{xia_input_count_rate,         "xia_input_count_rate","input_count_rate",XMAP_FLOAT64},
	{xia_output_count_rate,        "xia_output_count_rate","output_count_rate",XMAP_FLOAT64},
	{xia_sca_length,               "xia_sca_length","sca_length",XMAP_INT32},
/*	{xia_sca,                      "xia_sca","sca",XMAP_FLOAT64},*/ /* currently not supporting float64Array */
	{xia_run_active,               "xia_run_active","run_active",XMAP_INT32},
	{xia_buffer_full_a,            "xia_buffer_full_a","buffer_full_a",XMAP_INT32},
	{xia_buffer_full_b,            "xia_buffer_full_b","buffer_full_b",XMAP_INT32},
	{xia_buffer_len,               "xia_buffer_len","buffer_len",XMAP_INT32},
	{xia_buffer_a,                 "xia_buffer_a","buffer_a",XMAP_INT32ARRAY},
	{xia_buffer_b,                 "xia_buffer_b","buffer_b",XMAP_INT32ARRAY},
	{xia_current_pixel,            "xia_current_pixel","current_pixel",XMAP_INT32},
	{xia_buffer_overrun,           "xia_buffer_overrun","buffer_overrun",XMAP_INT32},
/*	{xia_module_statistics,        "xia_module_statistics","module_statistics",XMAP_FLOAT64ARRAY},
	{xia_module_mca,               "xia_module_mca","module_mca",XMAP_INT32ARRAY},*/
};

/* local functions */
xmap_command_t xmap_xia_get_cmd( asynUser* pasynUser );


xmap_command_t xmap_xia_get_cmd( asynUser* pasynUser )
{
	epicsInt32 reason = pasynUser->reason;
	return xmap_xia_commands[reason - XMAP_FIRST_XIA_CMD];
}

xmap_command_t xmap_xia_get_cmdreason( epicsInt32 reason )
{
	return xmap_xia_commands[reason - XMAP_FIRST_XIA_CMD];
}


asynStatus xmap_xia_checkError( asynUser* pasynUser, epicsInt32 xiastatus, char *xiacmd )
{
	if (xiastatus == XIA_SUCCESS) return asynSuccess;

	asynPrint( pasynUser, ASYN_TRACE_ERROR, "### drvXmap: XIA ERROR: %d (%s)\n", xiastatus, xiacmd );
	return asynError;
}


/* Get or set an XIA/Handel "Acquisition Value" parameter
   (Handel only supports float here) */
asynStatus xmap_xia_acq_val( asynUser* pasynUser, epicsFloat64* value, xmap_dir_enum dir)
{
	asynStatus status = asynError;
	epicsInt32 xiastatus, channel;
	xmap_command_t cmd;

	cmd = xmap_xia_get_cmd( pasynUser );
	pasynManager->getAddr(pasynUser, &channel);		/* Get the channel number */

	asynPrint(	pasynUser, ASYN_TRACE_FLOW, "xmap_xia_acq_val: xiacmd: '%s' ch: %d ptr to value: %.3f (R/W: %d)\n",
				cmd.xiaCmd, channel, *value, dir);

	if (dir == XMAP_GET)
	{
		xiastatus = xiaGetAcquisitionValues( channel, cmd.xiaCmd, (void*)value );
		status = xmap_xia_checkError( pasynUser, xiastatus, cmd.xiaCmd );
	} else if (dir == XMAP_SET)
	{
		xiastatus = xiaSetAcquisitionValues( channel, cmd.xiaCmd, (void*)value );
		status = xmap_xia_checkError( pasynUser, xiastatus, cmd.xiaCmd );
	}
	return status;
}

/* Get or set an XIA/Handel "Runtime Value"
   (integers, floats and arrays...)
   We only support readable run time commands. */
asynStatus xmap_xia_run_val(asynUser* pasynUser, void* value, epicsInt32* len, unsigned int interfaceType)
{
	asynStatus status = asynError;
	epicsInt32 xiastatus, channel;
	xmap_command_t cmd;

	pasynManager->getAddr(pasynUser, &channel);		/* Get the channel number */
	cmd = xmap_xia_get_cmd( pasynUser );

	asynPrint(pasynUser, ASYN_TRACE_FLOW, "xmap_xia_run_val: xiacmd: '%s' ch: %d\n", cmd.xiaCmd, channel);

	if ((interfaceType & cmd.interfaceType) == 0)
	{
		asynPrint(	pasynUser, ASYN_TRACE_FLOW, "xmap_xia_run_val: xiacmd: %s is not supported for interface type 0x%02H\n",
					cmd.xiaCmd, interfaceType);
		*len = 0;
		return asynError;
	}
	/* TODO: need to add a check if the value is supposed
	   to be an array. If this is the case we need to get
	   the size of the array and pass it to the len parameter. */

	xiastatus = xiaGetRunData( channel, cmd.xiaCmd, value );
	status = xmap_xia_checkError( pasynUser, xiastatus, cmd.xiaCmd );
	return status;
}

/* Do or readback a XIA/Handel "Board Operation"
   This applies to a whole module at one time. Can only write!
   Operations: apply, buffer_done, mapping_pixel_next supported */
asynStatus xmap_xia_board_op(asynUser* pasynUser, char* buf )
{
	asynStatus status = asynError;
	epicsInt32 xiastatus, channel, dummy;
	xmap_command_t cmd;

	cmd = xmap_xia_get_cmd( pasynUser );
	pasynManager->getAddr(pasynUser, &channel);		/* Get the channel number */

	asynPrint(pasynUser, ASYN_TRACE_FLOW, "xmap_xia_board_op: xiacmd: '%s' ch: %d buf: %d\n", cmd.xiaCmd, channel, (int)*buf);

	if (cmd.command == xia_buffer_done && buf != NULL) /* special board operation as it actually takes a parameter! */
	{
		xiastatus = xiaBoardOperation( channel, cmd.xiaCmd, (void*)buf );
		status = xmap_xia_checkError( pasynUser, xiastatus, cmd.xiaCmd );
		if (*buf == 'a')		/* swap the buffer around 'a' or 'b' for this particular channel. */
			*buf = 'b';
		else *buf = 'a';
	} else
	{
		xiastatus = xiaBoardOperation( channel, cmd.xiaCmd, (void*)&dummy );
		status = xmap_xia_checkError( pasynUser, xiastatus, cmd.xiaCmd );
	}
	return status;
}








